	.486p
	locals @@


code 	segment para public 'CODE' use16
	assume cs:code,ds:code

	org  0100h
Start:
	mov  ax,013h
	int  010h

	mov  dx,03C8h
	xor  ax,ax
	out  dx,al
	inc  dx

@@SetPal:
	mov  al,ah
	shr  al,2
	out  dx,al
	out  dx,al
	out  dx,al
	inc  ah
	jne  @@SetPal

	push 0A000h
	pop  es
	mov  ax,ds
	add  ax,65536/16
	mov  ds,ax
@@MainLoop:
	xor  si,si
	xor  eax,eax
	in   al,040h
	mov  ah,al
	in   al,041h
@@Noise:
	mov  [si],al
	mov  cx,8
@@RandLoop:
	rol  eax,1
	jnc  @@NoXor
	xor  eax,44
@@NoXor:
	loop @@RandLoop
	inc  si
	jne  @@Noise

	mov  bx,10
@@Blur:
	xor  ax,ax
	sub  si,257
	mov  di,3
@@Blur1:
	add  al,[si]
	adc  ah,0
	inc  si
	add  al,[si]
	adc  ah,0
	inc  si
	add  al,[si]
	adc  ah,0
	add  si,254
	dec  di
	jne  @@Blur1
	sub  si,257+254
	add  ax,4
	mov  dl,9
	div  dl
	mov  [si],al
	inc  si
	jne  @@Blur
	dec  bx
	jne  @@Blur

@@Scale:
	mov  al,[si]
	shl  al,2
	add  al,128
	mov  [si],al
	inc  si
	jne  @@Scale

	mov  cx,12
@@MergeLoop:
	mov  si,200
	xor  di,di
	xor  bx,bx
@@Draw:
	mov  dx,320
@@Draw1:
	mov  al,es:[di]
	mov  ah,7
	mul  ah
	add  al,[bx]
	adc  ah,0
	add  ax,4
	shr  ax,3
	mov  es:[di],al
	inc  di
	inc  bl
	dec  dx
	jne  @@Draw1
	inc  bh
	xor  bl,bl
	dec  si
	jne  @@Draw

	mov  dx,03DAh
@@VR1:
	in   al,dx
	test al,8
	je   @@VR1
@@VR2:
	in   al,dx
	test al,8
	jne  @@VR2

	dec  cx
	jne  @@MergeLoop

	mov  ah,1
	int  016h
	jz   @@MainLoop
	mov  ax,003h
	int  010h
	mov  ax,04C00h
	int  021h

code	ends
	end  Start
